#!/bin/csh -f
# #!/bin/csh -fx

#  TCppA.csh: translator from C code to TBCppA XML.
#  in TBCppA project: tracer-based CPP analyzer.
#  Copyright (c) 2006   Katsuhiko Gondow (gondow(at)cs.titech.ac.jp)
#  $Id: TBCppA.csh,v 1.7 2006/11/01 11:36:57 gondow Exp gondow $

# Usage: ./TBCppA.csh foo.c
#   (set environment variable 'TBCPPA_BINDIR' before execution.)

set SRC_FILE      = $1
set TBCPPA_FILE   = `realpath.exe $1`
set XML_FILE      = $1.xml
set TBCPPA_DBDIR  = ./TBCppA

setenv TBCPPA_DIR  $TBCPPA_BINDIR/$TBCPPA_DBDIR

# append $TBCPPA_DIR if not in path
echo $path | grep -q $TBCPPA_BINDIR
if ( $status ) then
  set path=($TBCPPA_BINDIR $path:q)
endif

if ($?TBCPPA_CPPOPT == 0) then
    setenv TBCPPA_CPPOPT 
endif

set CPP_CMD   = "gcc -E -P $TBCPPA_CPPOPT -nostdinc -include $TBCPPA_BINDIR/TBCppA.h -I$TBCPPA_DIR/usr/include -I$TBCPPA_DIR/usr/lib/gcc/i686-pc-cygwin/3.4.4/include"

tadd.exe      $SRC_FILE
tdbxml.exe    $TBCPPA_DIR/db_file

$CPP_CMD      $TBCPPA_DIR/$TBCPPA_FILE | txml.exe | tfix2.exe $XML_FILE

#$CPP_CMD      $TBCPPA_DIR/$TBCPPA_FILE > foo.E
#txml.exe < foo.E > foo.xml
#tfix2.exe $XML_FILE < foo.xml

# tifdef_src2html.exe  $SRC_FILE

#end-of-file
