/* CDLL: circular doubly-linked list.
   in TBCppA project: tracer-based CPP analyzer.
    Copyright (c) 2006 Katsuhiko Gondow (gondow(at)cs.titech.ac.jp)
    $Id: list.h,v 1.4 2006/11/01 11:36:57 gondow Exp gondow $ */
#ifndef TBCPPA_LIST_H
#define TBCPPA_LIST_H
#include <stdio.h>
/* ---------------------------------------------------------------------- */
struct CDLL {
    char *param_name; /* for tadd.y. assumes dynamically allocated */
    int  depth;       /* for tfix.c */
    int  type;        /* for tfix.c */
    struct CDLL *next, *prev;
};
/* ---------------------------------------------------------------------- */
void CDLL_init    (struct CDLL *head);
void CDLL_insert  (struct CDLL *head, char *param_name);
struct CDLL *CDLL_append  (struct CDLL *list1, struct CDLL *list2);
int  CDLL_query   (struct CDLL *head, char *param_name);
void CDLL_free    (struct CDLL *head);
int  CDLL_is_null (struct CDLL *head);
void CDLL_dump    (struct CDLL *head) __attribute__ ((unused));

struct CDLL *CDLL_pop  (struct CDLL *head);
void CDLL_top  (struct CDLL *head, int *depth, int *type);
void CDLL_push (struct CDLL *head, int depth, int type);
/* ---------------------------------------------------------------------- */
#endif /* TBCPPA_LIST_H */
