/* tadd: embedding CPP tracers in C programs.
   in TBCppA project: tracer-based CPP analyzer.
   Copyright (c) 2006   Katsuhiko Gondow (gondow(at)cs.titech.ac.jp)
   $Id: tadd.h,v 1.4 2006/11/01 11:36:57 gondow Exp gondow $ */


#ifndef TBCPPA_TADD_H
#define TBCPPA_TADD_H

#include "list.h"

#define LINE_FMT      "filename_ref='F%d' first_line='%d' first_column='%d' "\
                      "last_line='%d' last_column='%d' "
#define LINE_INFO(x)  idnum, (x).first_line, (x).first_column, (x).last_line, (x).last_column
#define LINE_INFO2(x,y)  idnum, (x).first_line, (x).first_column, (y).last_line, (y).last_column

struct lval {
    char        *str;    /* bare lexical string */
    char        *str2;   /* doubled string (eg., FOO -> FOO_1528552) */
    char        *tadd;   /* tracer-embedded and doubled string */
    struct CDLL *list;
    int          offset; /* current offset to directive_buf */
};

extern char *yytext;
extern FILE *yyin, *yyout, *lexout;
extern char *absolute_path;
extern int  idnum;
extern char **double_suffix_p;

extern int is_if_or_elif;
extern int func_mc_nest;
extern int directive_size;
extern char *directive_buf;

int yylex (void);
void tadd_unput (char *s);

#define YYSTYPE struct lval

#endif /* TBCPPA_TADD_H */

