<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<!--
<xsl:output method="xml" doctype-system="TBCppA.dtd" indent="yes"/>
-->
<xsl:template match="/">
    <xsl:value-of disable-output-escaping="yes"
	 select="comment()[contains(.,'DOCTYPE')][1]"/>
    <xsl:apply-templates/>
</xsl:template>

<xsl:template match="filename_list">
  <filename_list>
    <xsl:text disable-output-escaping="yes"><![CDATA[&db_file;]]></xsl:text>
  </filename_list>
</xsl:template>

<xsl:template match="lexical_info">
  <lexical_info>
  <xsl:text disable-output-escaping="yes"><![CDATA[&comm_file;]]></xsl:text>
  </lexical_info>
</xsl:template>

<xsl:template match="@*|node()">
    <xsl:choose>
    <!-- modify this subtree since this is not a macro call. -->
    <xsl:when test="(name(.)='macro_call') and normalize-space(is_defined)!='1'">
        <xsl:choose>
        <xsl:when test="@type='func'">
            <xsl:value-of select="@name"/>(<xsl:apply-templates select="double/arg" mode="output_arg"/>)
        </xsl:when>
        <xsl:otherwise>
            <xsl:value-of select="@name"/>
        </xsl:otherwise>
        </xsl:choose>
    </xsl:when>

    <!-- discard <is_defined>...</is_defined>; preserve all the others.  -->
    <xsl:when test="name(.)!='is_defined'">
	<xsl:copy>
	    <xsl:apply-templates select="@*|node()"/>
    	</xsl:copy>
    </xsl:when>
    <xsl:otherwise>
    </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="@*|node()" mode="output_arg">
    <xsl:if test='position()!=1'>, </xsl:if>
    <xsl:apply-templates select="node()"/>
</xsl:template>
</xsl:stylesheet>
